package xyz.lychee.lagfixer.libs.adventure.text.minimessage;

import xyz.lychee.lagfixer.libs.adventure.pointer.Pointered;
import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.adventure.text.minimessage.tag.resolver.ArgumentQueue;
import xyz.lychee.lagfixer.libs.adventure.text.minimessage.tag.resolver.TagResolver;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.annotations.ApiStatus.NonExtendable;

@NonExtendable
public interface Context {
   @Nullable Pointered target();

   @NotNull Pointered targetOrThrow();

   <T extends Pointered> @NotNull T targetAsType(final @NotNull Class<T> targetClass);

   @NotNull Component deserialize(final @NotNull String message);

   @NotNull Component deserialize(final @NotNull String message, final @NotNull TagResolver resolver);

   @NotNull Component deserialize(final @NotNull String message, final @NotNull TagResolver... resolvers);

   @NotNull ParsingException newException(final @NotNull String message, final @NotNull ArgumentQueue tags);

   @NotNull ParsingException newException(final @NotNull String message);

   @NotNull ParsingException newException(final @NotNull String message, final @Nullable Throwable cause, final @NotNull ArgumentQueue args);
}
